/*
 * button_debounce.c
 *
 * Created: 2016. 09. 07. 9:11:11
 * Author : AradiSzilard
 */ 

/******************************************************************************
* Include files
******************************************************************************/
#define F_CPU 8000000UL

#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>

/******************************************************************************
* Local Function Definitions
******************************************************************************/
int main(void)
{

	// Port init
	DDRA |= (1<<PA0);    //  PA0 output
	PORTA |= (1<<PA0);   //  PA0 high
	DDRD &= ~(1<<PD0);   //  PD0 input (EXTINT0)
	PORTD |= (1<<PD0);   //  PD0 pull-up
	EICRA = 0x02;        // EXTINT0 falling edge
	EIMSK |= (1<<INT0);  // Enable EXTINT0
	sei();

	while (1)
	{
		
		// If EXTINT0 is disabled
		if((EIMSK & (1<<INT0)) == 0)
		{
			// Wait for prell decay
			_delay_ms(250);
			//
			EIFR |= (1<<INTF0);   // Delete EXTINT0 flag (delete waiting interrupt)
			EIMSK |= (1<<INT0);  // Enable EXTINT0
		}
		
	}
}

/******************************************************************************
* Global Function Definitions
******************************************************************************/


/******************************************************************************
* Interrupt Routines
******************************************************************************/
ISR (INT0_vect)    // EXTINT0
{
	PORTA ^= (1<<PA0);
	EIMSK &= ~(1<<INT0);
}
